#ifndef FLOATH
#define FLOATH 

/* Float.h -- declarations for Float object

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Object.h"

extern Class class_Float;

class Float: public Object {
	double val;
	void parseFloat(istream& strm)	{ strm >> val; }
public:
	Float(double v =0)		{ val = v; }
	Float(fileDescTy&,Float&);
	Float(istream&);
	Float(istream&,Float&);
	double value()			{ return val; }
	double value(double newval)	{ return val = newval; }
	virtual int compare(const Object&);
	virtual obid	copy();			// { return shallowCopy(); }
	virtual void	deepenShallowCopy();	// {}
	virtual UNSIGNED hash();
	virtual const Class* isA();
	virtual bool isEqual(const Object&);
	virtual void printOn(ostream& strm);
	virtual void scanFrom(istream& strm);
	virtual const Class* species();
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
