#ifndef LOOKUPKEYH
#define LOOKUPKEYH 

/* LookupKey.h -- declarations for Dictionary LookupKey

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Object.h"

extern Class class_LookupKey;

class LookupKey: public Object {
	obid akey;
public:
	LookupKey(const Object& newKey =*nil);
	LookupKey(fileDescTy&,LookupKey&);
	LookupKey(istream&,LookupKey&);
	virtual int compare(const Object&);
	virtual void deepenShallowCopy();
	virtual UNSIGNED hash();
	virtual const Class* isA();
	virtual bool isEqual(const Object&);
	virtual obid key();
	virtual obid key(const Object& newkey);
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
	virtual obid value();
	virtual obid value(const Object& newvalue);
};

#endif
