#include "Point.h"
#include "OrderedCltn.h"

extern Class class_MyPoint;

class MyPoint : public Point {
public:
	MyPoint(int newx, int newy) : (newx,newy) {}
	MyPoint(fileDescTy&,MyPoint&) {}
	MyPoint(istream&,MyPoint&) {}
	~MyPoint()	{ release(); }
	int x()		{ return Point::xc; }
	int y()		{ return Point::yc; }
	int x(int newx)	{ Point::xc = newx; changed(); return Point::xc; }
	int y(int newy)	{ Point::yc = newy; changed(); return Point::yc; }
	virtual Class* isA();
};

DEFINE_CLASS(MyPoint,Point,1,NULL,NULL);

extern Class class_PointView;

class PointView : public Object {
	Point* p;
public:
	PointView(Point& newp)	{ p = &newp; p->addDependent(*this); update(*p,*nil); }
	PointView(fileDescTy&,PointView&) {}
	PointView(istream&,PointView&) {}
	~PointView()		{ p->removeDependent(*this); }
	virtual Class* isA();
	virtual void update(Object&, Object&);
	virtual void printOn(ostream& strm);
};

DEFINE_CLASS(PointView,Object,1,NULL,NULL);

void PointView::update(Object& p, Object& /*unused*/)
{
	cout << p.className() << " changed: " << p << "\n";
	cout.flush();
}

void PointView::printOn(ostream& strm)
{
	strm << className() << *p << "\n";
}

main()
{
	cout << "Test Object Dependencies\n";
	MyPoint p(0,0);
	PointView* v = new PointView(p);
	cout << p.dependents() << "\n";
	p.x(1); p.y(2);		/* should print changes */
	delete v;
	cout << p.dependents() << "\n";
	p.x(3); p.y(4);		/* should not print changes */
	v = new PointView(p);
	p.x(5); p.y(6);		/* should print changes */
	p.release();
	cout << p.dependents() << "\n";
	p.x(7); p.y(8);		/* should not print changes */
}
